/* DUView */

#import <Cocoa/Cocoa.h>

@class DUWindowController;

@interface DUView : NSView
{
  // outlets
    IBOutlet NSTextField *progressFileName;
    IBOutlet NSProgressIndicator *progressPercent;
    IBOutlet NSWindow *progressWin;
    IBOutlet DUWindowController *windowController;
  
  
  // state
  enum {
    St_empty,
    St_loading,
    St_ready  
  } state;
  
  // C data  
  char root_name[1024];
  struct FileNode *root_node;
  
  // display data
  double x_scale,y_scale,prev_y_scale;
  
  NSFont *font;
  NSDictionary *font_attrs;

  NSColor *data_color,*rsrc_color,*padding_color;
  
  // progress data  
  struct ProgressSpy *spy;
  NSTimer *progressTimer;
  
  // selection
  int selectedDepth; // valid elts in selectedStack  
  struct FileNode *selectedStack[256];
  char selectedName[1024];
  struct {
    double xmin,ymin,xmax,ymax;
  } selectedBBox;
  
}

- (id)initWithFrame:(NSRect)frame;

- (IBAction)open:(id)sender;
- (IBAction)openInWindow:(id)sender;
- (IBAction)showSelectedDir:(id)sender;
- (IBAction)revealSelectedDir:(id)sender;
- (IBAction)refreshSelectedDir:(id)sender;
- (IBAction)setYZoom:(id)sender;

- (BOOL)loadDirectory:(NSString*)nsFileName;

- (void)drawRect:(NSRect)rect;

- (void) handleSizeChange;
- (void) handleFontChange;

- (BOOL)isOpaque;


@end
